unit mfrdemo;

{
Dieses Beispiel zeigt lediglich eine Mglichkeit auf, mit den MFR-Modulen
ber eine Ethernet-Verbindung, unter Verwendung von Standard-Komponenten,
zu kommunizieren. Es wird nicht der Anspruch erhoben, dass die Vorgehensweise
einzigartig oder effizient ist! Das verwendete Protokoll ist TCP (Port 65200).
Achtung!
-- Die IP-Nummer wird nicht berprft.
-- Die Steuerzeichen werden fr die ListBox nicht ausgefiltert
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ScktComp;


type
  TForm1 = class(TForm)
    gb1: TGroupBox;
    btnTCPX: TSpeedButton;
    btnTCPI: TSpeedButton;
    btnTCPO: TSpeedButton;
    btnTCPOx: TSpeedButton;
    MFR_IP_Nummer: TEdit;
    lb: TListBox;
    btnClearListBox: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    b7: TCheckBox;
    b6: TCheckBox;
    b5: TCheckBox;
    b4: TCheckBox;
    b3: TCheckBox;
    b2: TCheckBox;
    b1: TCheckBox;
    b0: TCheckBox;
    mfr: TClientSocket;
    btnConnect: TSpeedButton;
    btnDisconnect: TSpeedButton;
    procedure btnTCPOxClick(Sender: TObject);
    procedure btnTCPXClick(Sender: TObject);
    procedure btnTCPIClick(Sender: TObject);
    procedure btnTCPOClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnClearListBoxClick(Sender: TObject);
    procedure mfrRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure btnConnectClick(Sender: TObject);
    procedure btnDisconnectClick(Sender: TObject);
    procedure mfrConnect(Sender: TObject; Socket: TCustomWinSocket);
  private
    { Private-Deklarationen }
    msg: string;
    bits: array[0..7] of ^TCheckBox;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
  begin
  lb.Clear;
  gb1.Caption := 'TCP - gesperrt';
  gb1.Enabled := false;
  bits[0] := @b0;
  bits[1] := @b1;
  bits[2] := @b2;
  bits[3] := @b3;
  bits[4] := @b4;
  bits[5] := @b5;
  bits[6] := @b6;
  bits[7] := @b7;
  end;

procedure TForm1.btnTCPOxClick(Sender: TObject);
  var
  i: integer;
  lo_nibble,hi_nibble: byte;
  begin
  lo_nibble := 64;
  hi_nibble := 64;
  for i:=0 to 3 do
    begin
    if bits[i]^.Checked then lo_nibble := lo_nibble + bits[i]^.Tag;
    end;
  for i:=4 to 7 do
    begin
    if bits[i]^.Checked then hi_nibble := hi_nibble + bits[i]^.Tag;
    end;
  msg := 'O' + char(hi_nibble) + char(lo_nibble) + #13;
  lb.Items.Add('>' + msg);
  mfr.Socket.SendText(msg);
  end;

procedure TForm1.btnTCPXClick(Sender: TObject);
  begin
  msg := 'X' + #13;
  lb.Items.Add('>' + msg);
  mfr.Socket.SendText(msg);
  end;

procedure TForm1.btnTCPIClick(Sender: TObject);
  begin
  msg := 'I' + #13;
  lb.Items.Add('>' + msg);
  mfr.Socket.SendText(msg);
  end;

procedure TForm1.btnTCPOClick(Sender: TObject);
  begin
  msg := 'O' + #13;
  lb.Items.Add('>' + msg);
  mfr.Socket.SendText(msg);
  end;

procedure TForm1.btnClearListBoxClick(Sender: TObject);
  begin
  lb.Clear;
  end;

procedure TForm1.mfrRead(Sender: TObject; Socket: TCustomWinSocket);
  begin
  lb.Items.Add('<' + mfr.Socket.ReceiveText);
  end;

procedure TForm1.btnConnectClick(Sender: TObject);
begin
  if mfr.Active = false then
    begin
    mfr.Host := MFR_IP_Nummer.Text;
    mfr.Port := 65200;
    mfr.Active := true;
    end
  else btnDisconnectClick(self);
end;

procedure TForm1.btnDisconnectClick(Sender: TObject);
  begin
  gb1.Caption := 'TCP - gesperrt';
  gb1.Enabled := false;
  mfr.Active := false;
  end;

procedure TForm1.mfrConnect(Sender: TObject; Socket: TCustomWinSocket);
  begin
  gb1.Caption := 'TCP - verbunden';
  gb1.Enabled := true;
  end;

end.
